routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

// Nos mostrará el formulario de login.
Route::get('/', 'Auth\LoginController@showLogin');

// Validamos los datos de inicio de sesión.
Route::post('/validar', 'Auth\LoginController@validarLogin');

    // Esta será nuestra ruta de bienvenida.
Route::get('dashboard', 'DashboardController@index');
Route::get('/busqueda/{busqueda}', 'DashboardController@busquedaTicket');
Route::get('/resultados', 'DashboardController@busqueda')->name('ticket.busqueda');


    // Esta será nuestra ruta de bienvenida.
Route::post('dashboard', 'DashboardController@indexFecha');
    // Esta ruta nos servirá para cerrar sesión.
Route::get('logout', 'Auth\LoginController@logOut');

    //Esta ruta es para crear cliente
    Route::resource('cliente', 'ClienteController');
    //ruta para desactivar y activar clientes
    Route::get('cliente/desactivar/{id}', 'ClienteController@desactivar');
    Route::get('cliente/activar/{id}', 'ClienteController@activar');

    //Rutas para marcas
    Route::resource('marca', 'MarcaController');
    //ruta para desactivar y activar marca
    Route::get('marca/desactivar/{id}', 'MarcaController@desactivar');
    Route::get('marca/activar/{id}', 'MarcaController@activar');
    Route::get('marca/validateNombre/{nombre}', 'MarcaController@validateNombre');

    //Esta ruta es para crear rma
    Route::resource('rma', 'RmaController');
    Route::get('/archivadosrma', 'RmaController@indexArchivados')->name('archivados');
    //Esta ruta es para crear rma
    Route::get('rma/historial/{id}', 'RmaController@historial');
    //ruta para formulario de entrada
    Route::get('entrada', 'RmaController@createE');
    //ruta para formulario de salida
    Route::get('salida', 'RmaController@createS');

    //Rutas para usuarios
    Route::resource('usuario', 'UsuarioController');
    //ruta para desactivar y activar usuario
    Route::get('usuario/desactivar/{id}', 'UsuarioController@desactivar');
    Route::get('usuario/activar/{id}', 'UsuarioController@activar');
    Route::get('usuario/validateUsername/{username}', 'UsuarioController@validateUsername');
    Route::get('usuario/validateCorreo/{email}', 'UsuarioController@validateCorreo');

    //Rutas para empresas
    Route::resource('empresa', 'EmpresaController');
    //ruta para desactivar y activar empresa
    Route::get('empresa/desactivar/{id}', 'EmpresaController@desactivar');
    Route::get('empresa/activar/{id}', 'EmpresaController@activar');
    Route::get('empresa/validateNombre/{nombre}', 'EmpresaController@validateNombre');


    //Esta ruta es para crear prioridades
    Route::resource('prioridad', 'PrioridadController');
    Route::get('prioridad/validateNombre/{nombre}', 'PrioridadController@validateNombre');

    //Esta ruta es para crear tipos de contrato
    Route::resource('tipoContrato', 'TipoContratoController');
    //ruta para desactivar y activar empresa
    Route::get('tipoContrato/desactivar/{id}', 'TipoContratoController@desactivar');
    Route::get('tipoContrato/activar/{id}', 'TipoContratoController@activar');
    Route::get('tipoContrato/validateNombre/{nombre}', 'TipoContratoController@validateNombre');

    //Esta ruta es para crear contratos
Route::resource('contrato', 'ContratoController');
    //Esta ruta es para crear Ticekts
Route::resource('ticket', 'TicketController');

Route::get('/seleccionarCliente/{id}/{emmpresa}', 'ClienteController@seleccion');
Route::get('/unSeleccionarCliente/{id}/{empresa}', 'ClienteController@unSeleccion');
Route::delete('/eliminar_ticket/{id}', 'TicketController@eliminarTicket')->name('ticket.eliminar');
Route::get('/RecordatorioCorreo', 'MailRememberController@recordarRespuesta');//ruta para correos persistentes de recordatorio de respuesta
    //Ruta para obtener todos los mails ingresados por correo
    Route::get('/mails', 'TicketController@tickets_mails');

    //Ruta para obtener todos los mails ingresados por correo
    Route::get('/todos', 'TicketController@allTickets');
        //Esta ruta es para ver los tickets ingresados validados
    Route::get('/ingresados', 'TicketController@tickets_ingresados');
        //Esta ruta es para ver los tickets ingresados que estan en revision
    Route::get('/revision', 'TicketController@tickets_revision');
        //Esta ruta es para ver los tickets ingresados que estan en revision
    Route::get('/proceso', 'TicketController@tickets_proceso');
        //Esta ruta es para ver los tickets ingresados que estan en revision
    Route::get('/respuesta', 'TicketController@tickets_respuesta');
        //Esta ruta es para ver los tickets ingresados que estan en revision
    Route::get('/cerrado', 'TicketController@tickets_cerrado');
    // tickets re abiertos
    Route::get('/re-abierto', 'TicketController@tickets_reabierto');

    //Esta ruta es para crear Ticekts
Route::post('/estadoTicket', 'TicketController@updateHistorico');
    //Esta ruta es para ver los tickets archivados
Route::get('/ticketArchivados', 'TicketController@archivados');
    //Esta ruta es para ver los tickets ingresados por correo
Route::get('/ticketMail', 'TicketController@indexMails');
    //Ruta para validar ticket desde el correo
Route::get('validar/{id}', 'TicketController@validar');
//valida i el ticketya esta siendo trabajado
Route::get('trabajoTicket/{id}', 'TicketController@insertarTiempoInicio');
    //Ruta para enviar correos
Route::get('mail/send', 'TicketController@send');
    //Ruta para enviar correos
Route::get('mail', 'TicketControllmailer@send1');
    //Ruta para enviar correos
Route::get('send', 'TicketController@enviar');
    // ruta para exportar pdf
Route::get('/customers/pdf','ClienteController@export_pdf');
    // ruta para obtener el listado de notificaciones
Route::get('listaNotificaciones', 'TicketController@notificaciones');

    // ruta para obtener el listado de ticket programados
Route::get('listaProgramados', 'RecordarNotificacionesController@programados');
    // ruta para obtener el listado de ticket programados por frecuencia
Route::get('/ticketProgramado', 'RecordarNotificacionesController@ticketFrecuencia');
    // ruta para obtener el listado de ticket programados
Route::get('listadoAbiertos', 'TicketController@listaAbiertos');
Route::get('/actualizarVistos', 'TicketController@actualizarVisto');

Route::get('notificacionesSistema', 'TicketController@notificacionesSistema');
Route::get('/notificacionVista/{id}', 'TicketController@actualizarNotificacionesVista');
Route::get('/notificacionVistaTecnico/{id}', 'TicketController@actualizarNotificacionesVistaTecnico');

    // ruta para actualizar el tiempo
Route::get('updateTiempo/{id}/{tiempo}', 'TicketController@updateTiempo');

Route::get('select_clientes/{id}', 'TicketController@clientes');
Route::get('select_info/{id}', 'TicketController@cliente_info');



Auth::routes();

app/contrato.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class contrato extends Model
{
    /**
     * The table associated with the model.
     * 
     * @var string
     */
    protected $table = 'contrato';

    /**
     * The primary key for the model.
     * 
     * @var string
     */
    protected $primaryKey = 'idcontrato';
    /**
     * The attributes that are mass assignable.
     *
     * @var array
     */
    protected $fillable = ['fechaInicio','FechaFin','TipoContrato_idtipoContrato','Cliente_idcliente',
    ];

    public function tipoContrato()
    {
        return $this->belongsTo('App\tipoContrato', 'TipoContrato_idtipoContrato', 'idtipoContrato');
    }

    public function cliente()
    {
        return $this->belongsTo('App\cliente', 'Cliente_idcliente', 'idcliente');
    }

}

app/Http/Controllers/ContratoController.php
<?php

namespace App\Http\Controllers;

use App\contrato;
use App\cliente;
use App\tipoContrato;
use Illuminate\Http\Request;

class ContratoController extends Controller
{
    public function __construct() { 
        $this->middleware('preventBackHistory');
        $this->middleware('auth'); 
    }
        /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        //
        $contratos = contrato::orderBy('idcontrato','DESC')->paginate(5);
        return view('Contrato.index',compact('contratos')); 
    }
 
    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        //
        $tipoContratos = tipoContrato::all( ['idtipoContrato', 'nombre'] ); 
        $clientes = cliente::where('estado', 1)->get();
        return view('Contrato.create')->with('tipoContratos', $tipoContratos)->with('clientes', $clientes);
    }
 
    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        //
        $this->validate($request,['fechaInicio'=>'required', 'fechaFin'=>'required', 'TipoContrato_idtipoContrato'=>'required', 'Cliente_idcliente'=>'required']);
        contrato::create($request->all());
        return redirect()->route('contrato.index')->with('success','Registro creado satisfactoriamente');
    }
 
    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        $libros= contrato::find($id);
        return  view('Contrato.show',compact('libros'));
    }
 
    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        //
        $tipoContratos = tipoContrato::all( ['idtipoContrato', 'nombre'] );
        $clientes = cliente::where('estado', 1)->get();
        $contrato= contrato::find($id);
        return view('Contrato.edit',compact('contrato'))->with('tipoContratos', $tipoContratos)->with('clientes', $clientes);
    }
 
    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)    {
        //
        $this->validate($request,['fechaInicio'=>'required', 'fechaFin'=>'required', 'TipoContrato_idtipoContrato'=>'required', 'Cliente_idcliente'=>'required']);
 
        contrato::find($id)->update($request->all());
        return redirect()->route('contrato.index')->with('success','Registro actualizado satisfactoriamente');
 
    }
 
    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        //
        contrato::find($id)->delete();
        return redirect()->route('contrato.index')->with('success','Registro eliminado satisfactoriamente');
    }
}

resources/views/Contrato/create.blade.php
@extends('Layout.layout')
@section('content')
<div id="base">
    <div class="row">
        <section class="content" id="content">
            <div class="col-md-8 col-md-offset-2">
                @if (count($errors) > 0)
                <div class="alert alert-danger">
                    <strong>Error!</strong> Revise los campos obligatorios.<br><br>
                    <ul>
                        @foreach ($errors->all() as $error)
                        <li>{{ $error }}</li>
                        @endforeach
                    </ul>
                </div>
                @endif
                @if(Session::has('success'))
                <div class="alert alert-info">
                    {{Session::get('success')}}
                </div>
                @endif

                <div class="panel panel-default">
                    <div class="panel-heading">
                        <h3 class="panel-title">Nuevo Contrato</h3>
                    </div>
                    <div class="panel-body">
                        <div class="table-container">
                            <form method="POST" action="{{ route('contrato.store') }}" role="form" id="accion_form">
                                {{ csrf_field() }}
                                <div class="row">
                                    <div class="col-xs-6 col-sm-6 col-md-6">
                                        <div class="form-group">
                                            <input type="date" name="fechaInicio" min="<?=date('Y-m-d')?>"
                                                id="fechaInicio" data-date="" data-date-format="YYYY-MMMM-DD"
                                                value="<?=date('Y-m-d')?>" class="form-control input-sm"
                                                placeholder="Nombres">
                                        </div>
                                    </div>
                                    <div class="col-xs-6 col-sm-6 col-md-6">
                                        <div class="form-group">
                                            <input type="date" name="fechaFin" min="<?=date('Y-m-d')?>" id="fechaFinal"
                                                data-date="" data-date-format="YYYY-MMMM-DD" value="<?=date('Y-m-d')?>"
                                                class="form-control input-sm" placeholder="Apellidos">
                                        </div>
                                    </div>
                                    <div class="col-xs-6 col-sm-6 col-md-6">
                                        <div class="form-group">

                                            <label for="TipoContrato_idtipoContrato">Tipo de contrato</label>
                                            <select id="TipoContrato_idtipoContrato" onchange="select()"
                                                name="TipoContrato_idtipoContrato" class="form-control">
                                                @if($tipoContratos->count())
                                                @foreach($tipoContratos as $list)
                                                <option value="{{ $list->idtipoContrato}}">{{ $list->nombre }}</option>
                                                @endforeach
                                                @endif
                                            </select>

                                        </div>
                                    </div>
                                    <div class="col-xs-6 col-sm-6 col-md-6">
                                        <div class="form-group">

                                            <label for="Cliente_idcliente">Clientes</label>
                                            <select id="Cliente_idcliente" onchange="select()" name="Cliente_idcliente"
                                                class="form-control">
                                                @if($clientes->count())
                                                @foreach($clientes as $list)
                                                <option value="{{ $list->idcliente}}">{{ $list->nombres }}
                                                    {{$list->apellidos }}</option>
                                                @endforeach
                                                @endif
                                            </select>

                                        </div>
                                    </div>
                                </div>
                                <div class="row">

                                    <div class="col-xs-12 col-sm-12 col-md-12">
                                        <input type="submit" value="Guardar" class="btn btn-success btn-block">
                                        <a href="{{ route('cliente.index') }}" class="btn btn-info btn-block">Atrás</a>
                                    </div>

                                </div>
                            </form>
                        </div>
                    </div>

                </div>
            </div>
        </section>
    </div>
    <script src="{{ asset('js/notify.js')}}"></script>
    <script src="{{ asset('js/notificaciones.js')}}"></script>
    @endsection

resources/views/Contrato/edit.blade.php
@extends('Layout.layout')
@section('content')
<div id="base">
    <div class="row">
        <section class="content" id="content">
            <div class="col-md-8 col-md-offset-2">
                @if (count($errors) > 0)
                <div class="alert alert-danger">
                    <strong>Error!</strong> Revise los campos obligatorios.<br><br>
                    <ul>
                        @foreach ($errors->all() as $error)
                        <li>{{ $error }}</li>
                        @endforeach
                    </ul>
                </div>
                @endif
                @if(Session::has('success'))
                <div class="alert alert-info">
                    {{Session::get('success')}}
                </div>
                @endif

                <div class="panel panel-default">
                    <div class="panel-heading">
                        <h3 class="panel-title">Actualizar Contrato</h3>
                    </div>
                    <div class="panel-body">
                        <div class="table-container">
                            <form method="POST" action="{{ route('contrato.update',$contrato->idcontrato) }}"
                                role="form" id="accion_form">
                                {{ csrf_field() }}
                                <input name="_method" type="hidden" value="PATCH">
                                <div class="row">
                                    <div class="col-xs-6 col-sm-6 col-md-6">
                                        <div class="form-group">
                                            <input type="date" name="fechaInicio" min="<?=date('Y-m-d')?>"
                                                id="fechaInicio" data-date="" data-date-format="YYYY-MMMM-DD"
                                                value="{{$contrato->fechaInicio}}" class="form-control input-sm"
                                                placeholder="Nombres">
                                        </div>
                                    </div>
                                    <div class="col-xs-6 col-sm-6 col-md-6">
                                        <div class="form-group">
                                            <input type="date" name="fechaFin" min="<?=date('Y-m-d')?>" id="fechaFin"
                                                data-date="" data-date-format="YYYY-MMMM-DD"
                                                value="{{$contrato->fechaFin}}" class="form-control input-sm"
                                                placeholder="Apellidos">
                                        </div>
                                    </div>
                                    <div class="col-xs-6 col-sm-6 col-md-6">
                                        <div class="form-group">

                                            <label for="TipoContrato_idtipoContrato">Tipo de contrato</label>
                                            <select id="TipoContrato_idtipoContrato" onchange="select()"
                                                name="TipoContrato_idtipoContrato" class="form-control">
                                                @if($tipoContratos->count())
                                                @foreach($tipoContratos as $list)
                                                @if($list->idtipoContrato == $contrato->idtipoContrato)
                                                <option value="{{ $list->idtipoContrato}}" selected>{{ $list->nombre }}
                                                </option>
                                                @else
                                                <option value="{{ $list->idtipoContrato}}">{{ $list->nombre }}</option>
                                                @endif
                                                @endforeach
                                                @endif
                                            </select>

                                        </div>
                                    </div>
                                    <div class="col-xs-6 col-sm-6 col-md-6">
                                        <div class="form-group">

                                            <label for="Cliente_idcliente">Clientes</label>
                                            <select id="Cliente_idcliente" onchange="select()" name="Cliente_idcliente"
                                                class="form-control">
                                                @if($clientes->count())
                                                @foreach($clientes as $list)
                                                @if($list->idcliente == $contrato->Cliente_idcliente)
                                                <option value="{{ $list->idcliente}}" selected="">{{ $list->nombres }}
                                                    {{$list->apellidos }}</option>
                                                @else
                                                <option value="{{ $list->idcliente}}">{{ $list->nombres }}
                                                    {{$list->apellidos }}</option>
                                                @endif
                                                @endforeach
                                                @endif
                                            </select>

                                        </div>
                                    </div>
                                </div>
                                <div class="row">

                                    <div class="col-xs-12 col-sm-12 col-md-12">
                                        <input type="submit" value="Actualizar" class="btn btn-success btn-block">
                                        <a href="{{ route('cliente.index') }}" class="btn btn-info btn-block">Atrás</a>
                                    </div>

                                </div>
                            </form>
                        </div>
                    </div>

                </div>
            </div>
        </section>
    </div>
    <script src="{{ asset('js/notify.js')}}"></script>
    <script src="{{ asset('js/notificaciones.js')}}"></script>
    @endsection

resources/views/Contrato/index.blade.php
@extends('Layout.layout')
@section('content')
<!-- BEGIN BASE-->
<div id="base">
    <div class="row">
        <section class="content" id="content">
            <div class="col-md-8 col-md-offset-2">
                <div class="panel panel-default">
                    <div class="panel-body">
                        <div class="pull-left">
                            <h3>Lista de contrato</h3>
                        </div>
                        <div class="pull-right">
                            <div class="btn-group">
                                <a href="{{ route('contrato.create') }}" class="btn btn-info">Añadir Contrato</a>
                            </div>
                        </div>
                        <div class="table-container">
                            <table id="mytable" class="table table-bordred table-striped">
                                <thead>
                                    <th>Cliente</th>
                                    <th>Tipo de Contrato</th>
                                    <th>Estado</th>
                                    <th>Fecha de Inicio</th>
                                    <th>Fecha Final</th>
                                </thead>
                                <tbody>
                                    @if($contratos->count())
                                    @foreach($contratos as $contrato)
                                    <tr>
                                        <td>{{$contrato->cliente->nombres}} {{$contrato->cliente->apellidos}}</td>
                                        <td>{{$contrato->tipoContrato->nombre}}</td>
                                        <td><?php if( $contrato->created_at < NOW() ){ echo "Vigente"; }else{ echo "Vencido"; } ?>
                                        </td>
                                        <td>{{$contrato->fechaInicio}}</td>
                                        <td>{{$contrato->fechaFin}}</td>
                                        <td><a class="btn btn-primary btn-xs"
                                                href="{{action('ContratoController@edit', $contrato->idcontrato)}}"><span
                                                    class="glyphicon glyphicon-pencil"></span></a></td>
                                        <td>
                                            <form
                                                action="{{action('ContratoController@destroy', $contrato->idcontrato)}}"
                                                method="post">
                                                {{csrf_field()}}
                                                <input name="_method" type="hidden" value="DELETE">

                                                <button class="btn btn-danger btn-xs" type="submit"><span
                                                        class="glyphicon glyphicon-trash"></span></button>
                                            </form>
                                        </td>
                                    </tr>
                                    @endforeach
                                    @else
                                    <tr>
                                        <td colspan="8">No hay registro !!</td>
                                    </tr>
                                    @endif
                                </tbody>

                            </table>
                        </div>
                        {{ $contratos->links() }}
                    </div>

                </div>
            </div>
        </section>
    </div>

    <script src="{{ asset('js/notify.js')}}"></script>
    <script src="{{ asset('js/notificaciones.js')}}"></script>
    @endsection